apiVersion: v1
kind: Service
metadata:
  name: nginx
  labels:
    app: nginx
spec:
  type: LoadBalancer
  selector:
    app: nginx
  ports:
    - port: 80
      name: web

---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: website
  labels:
    app: nginx
spec:
  replicas: 3
  selector:
    matchLabels:
      app: nginx
  template:
    metadata:
      labels:
        app: nginx
        tier: web
    spec:
      topologySpreadConstraints:
        - maxSkew: 1
          topologyKey: kubernetes.io/hostname
          whenUnsatisfiable: ScheduleAnyway
          labelSelector:
            matchLabels:
              app: nginx
              tier: web
      containers:
        - name: nginx
          image: nginx:1.25-alpine-slim
          ports:
            - containerPort: 80
              name: website
          volumeMounts:
            - name: nginx-config
              mountPath: /usr/share/nginx/html
              readOnly: true
      volumes:
        - name: nginx-config
          configMap:
            name: location-html

---

apiVersion: v1
kind: ConfigMap
metadata:
  name: location-html
data:
  index.html: |
    <!DOCTYPE html>
    <html lang="en">
    <head>
        <title>Location 5 Configuration</title>
    </head>
    <body>
        <h1>This is for Rockies Clusters!</h1>
        <h3>Location 5</h3>
    </body>
    </html>